# Synapso

**Zero-trust. Local-first. Built in the open.**

[![Python Version](https://img.shields.io/badge/python-3.8%2B-blue)](https://www.python.org/downloads/)
[![License](https://img.shields.io/badge/license-Apache%202.0-green)](https://opensource.org/license/apache-2-0)
[![Development Status](https://img.shields.io/badge/status-active%20development-yellow)](https://github.com/ganeshpalanikumar/synapso)
[![Project Stage: Pre-MVP](https://img.shields.io/badge/stage-pre--MVP-orange)](#)
[![Built in Public](https://img.shields.io/badge/built%20in-public-purple)](https://github.com/ganesh-palanikumar/synapso)
[![Last Commit](https://img.shields.io/github/last-commit/ganesh-palanikumar/synapso)](https://github.com/ganesh-palanikumar/synapso/commits/main)

**Keywords:** `semantic-search` `local-first` `privacy` `knowledge-management` `vector-database` `llm` `embeddings` `python` `sqlite` `cli` `markdown` `plain-text` `zero-trust` `open-source`

**Synapso** is a privacy-conscious knowledge system designed to bring **semantic search** to your plain text notes (`.txt`, `.md`)—**without uploading anything anywhere**.

It's built for people who care about **control, clarity, and clean architecture**.

---

## 🚧 Current Status: Rebuilding from Scratch

Synapso has been rebooted as of version `0.2.0`.

The goal is to build a **fast, minimal, inspectable system** that:
- Runs locally with zero network chatter
- Indexes `.txt` and `.md` files
- Embeds them using LLM-powered chunkers
- Stores everything in your local vector store
- Keeps logs you can read, audit, and trust

No cloud sync. No hidden calls. No black boxes.

---

## 📦 Installation

```bash
pip install synapso

```

## 🧠 Architecture (WIP)

Synapso would be completely local, with zero network chatter. It would use sqlite dbs for both relational and vector storage. The querying interface would be CLI. Later, I am planning to include a local web GUI and maybe a Mac app.

## 🛠 Philosophy

Synapso is meant to be a local-first zero-trust privacy-aware interface to query and 'talk' to your knowledge base. As such, it does not make sense to build it behind closed doors. As a result, I am building Synapso in the open. Every line, every commit, every bad decision : it is all out there for anyone to see. 

This is not just a product. It is a journal of how I think as a builder and engineer. 

## 📖 Weekly Devlog

Every Wednesday, I will try to post a new update on [HackerNoon](https://hackernoon.com/u/ganeshpalanikumar) and [Medium](https://medium.com/me/stories/drafts). Stay tuned! The first log is coming up on May 28, 2025!

## 🤝 License & Contributions
- This project is licensed under [Apache 2.0](https://opensource.org/license/apache-2-0)
- The source code is open.
- Contributions are closed - this may change later.
- For now, feel free to explore, fork, or follow along.

## ✉️ Contact
[ganesh@synapso.xyz](<mailto:ganesh@synapso.xyz>)

[Linkedin](https://www.linkedin.com/in/ganesh-palanikumar/)

If you're into privacy-first tools, semantic search, or just want to see a system built line by line—come along for the ride.
